Page MenuHomeVyOS Platform

Duplicate address detection option supporting ARP
In progress, LowPublicFEATURE REQUEST

Description

Duplicate address detection option supporting ARP, and is designed with the following commands:

force arp duplicate interface <interface> address <address> [count <count>]

Details

Difficulty level
Easy (less than an hour)
Version
-
Why the issue appeared?
Will be filled on close
Is it a breaking change?
Perfectly compatible

Related Objects

StatusSubtypeAssignedTask
ResolvedFEATURE REQUESTjack9603301
In progressFEATURE REQUESTjack9603301
In progressFEATURE REQUESTjack9603301

Event Timeline

jack9603301 changed the task status from Open to In progress.Jul 20 2020, 4:51 AM
jack9603301 claimed this task.
jack9603301 created this task.

@c-po Arping has the following options. I wonder if there is a better way to help you freely combine these options?

Usage:

arping [options] <destination>

Options:

-f            quit on first reply
-q            be quiet
-b            keep on broadcasting, do not unicast
-D            duplicate address detection mode
-U            unsolicited ARP mode, update your neighbours
-A            ARP answer mode, update your neighbours
-V            print version and exit
-c <count>    how many packets to send
-w <timeout>  how long to wait for a reply
-i <interval> set interval between packets (default: 1 second)
-I <device>   which ethernet device to use
-s <source>   source ip address
<destination> dns name or ip address
jack9603301 updated the task description. (Show Details)Jul 20 2020, 5:08 AM
jack9603301 triaged this task as Low priority.Jul 20 2020, 5:39 AM
c-po added a comment.Jul 20 2020, 6:58 AM

Its always a good idea to research how other vendors are doong it - e.g. Arista, Cisco, Juniper and see if there is. common CLI ground.

Sorry, that sounds good, but I don't quite understand what you mean?

jack9603301 added a comment.EditedJul 20 2020, 7:47 AM

@c-po In my opinion, it is not improper for routers to support some commonly used toolsets, such as arping, which can be used to locate the MAC address of the IPv4 host in a LAN, or to detect whether ARP attacks have occurred in the LAN, or to test the security (ARP can be forged)

Arping can even be used to detect whether there is an IP conflict in the LAN

Of course, for routers, this is not the main function

jack9603301 updated the task description. (Show Details)Jul 20 2020, 7:58 AM
jack9603301 updated the task description. (Show Details)
jack9603301 renamed this task from Support arping construction to Support the construction and monitoring of ARP Protocol.Jul 20 2020, 8:07 AM
jack9603301 added a comment.EditedJul 20 2020, 8:21 AM

@c-po Would it be great if the XML framework had a way to do something like ping?

jack9603301 renamed this task from Support the construction and monitoring of ARP Protocol to Support the construction of ARP Protocol.Jul 20 2020, 10:42 AM
jack9603301 updated the task description. (Show Details)
jack9603301 updated the task description. (Show Details)Jul 20 2020, 10:58 AM
c-po added a comment.Jul 20 2020, 1:59 PM

We have a ping CLI implementation

I have found this implementation, but I don't know how to use it for my implementation. At present, I work in the XML framework of vyos-1x. I have provided a primary implementation for the time being. For details, please refer to:

https://github.com/vyos/vyos-1x/pull/508

pasik added a subscriber: pasik.Jul 20 2020, 6:41 PM

@c-po Please merge my pr

jack9603301 changed Difficulty level from Unknown (require assessment) to Easy (less than an hour).Jul 22 2020, 6:47 AM
jack9603301 changed Is it a breaking change? from Unspecified (possibly destroys the router) to Perfectly compatible.

@c-po This PR has been open for several days, requesting a merge

https://github.com/vyos/vyos-1x/pull/508

c-po added a comment.Jul 25 2020, 10:00 PM

Hi @jack9603301 your PRs are much appreciated but triggering my eMail inbox won't get your stuff merged faster - it actually will be quiet the opposite as I think you will trigger me again when it's urgent.

As most of the developers I have a regular job and are also busy with VyOS development.

jack9603301 updated the task description. (Show Details)Jul 26 2020, 6:48 AM

@c-po I have changed the top-level command, maybe it's better, can you help me see it, if possible, request a merge, otherwise, please reply?

@c-po Can you take a look at this PR for me?

jack9603301 renamed this task from Support the construction of ARP Protocol to Duplicate address detection option supporting ARP.Aug 3 2020, 1:00 AM
jack9603301 updated the task description. (Show Details)

@c-po Change the task and add duplicate address detection option in force ARP